#include <cxxabi.h>
#include <typeinfo>

namespace jlpolymake {

jlcxx::ArrayRef<jl_value_t*> get_type_names() {
    int          status;
    char*        realname;
    int          number_of_types = 101+1;
    jl_value_t** type_name_tuples = new jl_value_t*[2 * number_of_types];
    int          i = 0;
    type_name_tuples[i] = jl_cstr_to_string("to_int");
    realname = abi::__cxa_demangle(typeid(pm::Int).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_integer");
    realname = abi::__cxa_demangle(typeid(pm::Integer).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_rational");
    realname = abi::__cxa_demangle(typeid(pm::Rational).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_double");
    realname = abi::__cxa_demangle(typeid(double).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_quadraticextension_rational");
    realname = abi::__cxa_demangle(typeid(pm::QuadraticExtension<pm::Rational>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_tropicalnumber_min_rational");
    realname = abi::__cxa_demangle(typeid(pm::TropicalNumber<pm::Min,pm::Rational>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_tropicalnumber_max_rational");
    realname = abi::__cxa_demangle(typeid(pm::TropicalNumber<pm::Max,pm::Rational>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_matrix_int");
    realname = abi::__cxa_demangle(typeid(pm::Matrix<pm::Int>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_matrix_integer");
    realname = abi::__cxa_demangle(typeid(pm::Matrix<pm::Integer>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_matrix_rational");
    realname = abi::__cxa_demangle(typeid(pm::Matrix<pm::Rational>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_matrix_double");
    realname = abi::__cxa_demangle(typeid(pm::Matrix<double>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_matrix_quadraticextension_rational");
    realname = abi::__cxa_demangle(typeid(pm::Matrix<pm::QuadraticExtension<pm::Rational>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_matrix_tropicalnumber_min_rational");
    realname = abi::__cxa_demangle(typeid(pm::Matrix<pm::TropicalNumber<pm::Min,pm::Rational>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_matrix_tropicalnumber_max_rational");
    realname = abi::__cxa_demangle(typeid(pm::Matrix<pm::TropicalNumber<pm::Max,pm::Rational>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_vector_int");
    realname = abi::__cxa_demangle(typeid(pm::Vector<pm::Int>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_vector_integer");
    realname = abi::__cxa_demangle(typeid(pm::Vector<pm::Integer>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_vector_rational");
    realname = abi::__cxa_demangle(typeid(pm::Vector<pm::Rational>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_vector_double");
    realname = abi::__cxa_demangle(typeid(pm::Vector<double>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_vector_quadraticextension_rational");
    realname = abi::__cxa_demangle(typeid(pm::Vector<pm::QuadraticExtension<pm::Rational>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_vector_tropicalnumber_min_rational");
    realname = abi::__cxa_demangle(typeid(pm::Vector<pm::TropicalNumber<pm::Min,pm::Rational>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_vector_tropicalnumber_max_rational");
    realname = abi::__cxa_demangle(typeid(pm::Vector<pm::TropicalNumber<pm::Max,pm::Rational>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_array_int");
    realname = abi::__cxa_demangle(typeid(pm::Array<pm::Int>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_array_integer");
    realname = abi::__cxa_demangle(typeid(pm::Array<pm::Integer>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_array_rational");
    realname = abi::__cxa_demangle(typeid(pm::Array<pm::Rational>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_array_double");
    realname = abi::__cxa_demangle(typeid(pm::Array<double>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_array_quadraticextension_rational");
    realname = abi::__cxa_demangle(typeid(pm::Array<pm::QuadraticExtension<pm::Rational>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_array_tropicalnumber_min_rational");
    realname = abi::__cxa_demangle(typeid(pm::Array<pm::TropicalNumber<pm::Min,pm::Rational>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_array_tropicalnumber_max_rational");
    realname = abi::__cxa_demangle(typeid(pm::Array<pm::TropicalNumber<pm::Max,pm::Rational>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_bigobject");
    realname = abi::__cxa_demangle(typeid(pm::perl::BigObject).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_pair_array_int_array_int");
    realname = abi::__cxa_demangle(typeid(std::pair<pm::Array<pm::Int>,pm::Array<pm::Int>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_array_pair_array_int_array_int");
    realname = abi::__cxa_demangle(typeid(pm::Array<std::pair<pm::Array<pm::Int>,pm::Array<pm::Int>>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_pair_int_int");
    realname = abi::__cxa_demangle(typeid(std::pair<pm::Int,pm::Int>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_list_pair_int_int");
    realname = abi::__cxa_demangle(typeid(std::list<std::pair<pm::Int,pm::Int>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_list_list_pair_int_int");
    realname = abi::__cxa_demangle(typeid(std::list<std::list<std::pair<pm::Int,pm::Int>>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_pair_int_list_list_pair_int_int");
    realname = abi::__cxa_demangle(typeid(std::pair<pm::Int,std::list<std::list<std::pair<pm::Int,pm::Int>>>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_array_pair_int_int");
    realname = abi::__cxa_demangle(typeid(pm::Array<std::pair<pm::Int,pm::Int>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_array_list_pair_int_int");
    realname = abi::__cxa_demangle(typeid(pm::Array<std::list<std::pair<pm::Int,pm::Int>>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_pair_integer_int");
    realname = abi::__cxa_demangle(typeid(std::pair<pm::Integer,pm::Int>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_list_pair_integer_int");
    realname = abi::__cxa_demangle(typeid(std::list<std::pair<pm::Integer,pm::Int>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_pair_vector_int_array_int");
    realname = abi::__cxa_demangle(typeid(std::pair<pm::Vector<pm::Int>,pm::Array<pm::Int>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_pair_vector_integer_array_int");
    realname = abi::__cxa_demangle(typeid(std::pair<pm::Vector<pm::Integer>,pm::Array<pm::Int>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_pair_vector_rational_array_int");
    realname = abi::__cxa_demangle(typeid(std::pair<pm::Vector<pm::Rational>,pm::Array<pm::Int>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_set_int");
    realname = abi::__cxa_demangle(typeid(pm::Set<pm::Int>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_set_set_int");
    realname = abi::__cxa_demangle(typeid(pm::Set<pm::Set<pm::Int>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_array_set_int");
    realname = abi::__cxa_demangle(typeid(pm::Array<pm::Set<pm::Int>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_array_set_set_int");
    realname = abi::__cxa_demangle(typeid(pm::Array<pm::Set<pm::Set<pm::Int>>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_array_string");
    realname = abi::__cxa_demangle(typeid(pm::Array<std::string>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_array_array_int");
    realname = abi::__cxa_demangle(typeid(pm::Array<pm::Array<pm::Int>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_array_array_integer");
    realname = abi::__cxa_demangle(typeid(pm::Array<pm::Array<pm::Integer>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_array_array_rational");
    realname = abi::__cxa_demangle(typeid(pm::Array<pm::Array<pm::Rational>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_array_array_set_int");
    realname = abi::__cxa_demangle(typeid(pm::Array<pm::Array<pm::Set<pm::Int>>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_array_matrix_integer");
    realname = abi::__cxa_demangle(typeid(pm::Array<pm::Matrix<pm::Integer>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_array_bigobject");
    realname = abi::__cxa_demangle(typeid(pm::Array<pm::perl::BigObject>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_sparsematrix_int");
    realname = abi::__cxa_demangle(typeid(pm::SparseMatrix<pm::Int>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_sparsematrix_integer");
    realname = abi::__cxa_demangle(typeid(pm::SparseMatrix<pm::Integer>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_sparsematrix_rational");
    realname = abi::__cxa_demangle(typeid(pm::SparseMatrix<pm::Rational>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_sparsematrix_double");
    realname = abi::__cxa_demangle(typeid(pm::SparseMatrix<double>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_sparsematrix_quadraticextension_rational");
    realname = abi::__cxa_demangle(typeid(pm::SparseMatrix<pm::QuadraticExtension<pm::Rational>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_sparsematrix_tropicalnumber_min_rational");
    realname = abi::__cxa_demangle(typeid(pm::SparseMatrix<pm::TropicalNumber<pm::Min,pm::Rational>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_sparsematrix_tropicalnumber_max_rational");
    realname = abi::__cxa_demangle(typeid(pm::SparseMatrix<pm::TropicalNumber<pm::Max,pm::Rational>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_sparsevector_int");
    realname = abi::__cxa_demangle(typeid(pm::SparseVector<pm::Int>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_sparsevector_integer");
    realname = abi::__cxa_demangle(typeid(pm::SparseVector<pm::Integer>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_sparsevector_rational");
    realname = abi::__cxa_demangle(typeid(pm::SparseVector<pm::Rational>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_sparsevector_double");
    realname = abi::__cxa_demangle(typeid(pm::SparseVector<double>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_sparsevector_quadraticextension_rational");
    realname = abi::__cxa_demangle(typeid(pm::SparseVector<pm::QuadraticExtension<pm::Rational>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_sparsevector_tropicalnumber_min_rational");
    realname = abi::__cxa_demangle(typeid(pm::SparseVector<pm::TropicalNumber<pm::Min,pm::Rational>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_sparsevector_tropicalnumber_max_rational");
    realname = abi::__cxa_demangle(typeid(pm::SparseVector<pm::TropicalNumber<pm::Max,pm::Rational>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_unipolynomial_int_int");
    realname = abi::__cxa_demangle(typeid(pm::UniPolynomial<pm::Int,pm::Int>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_unipolynomial_integer_int");
    realname = abi::__cxa_demangle(typeid(pm::UniPolynomial<pm::Integer,pm::Int>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_unipolynomial_rational_int");
    realname = abi::__cxa_demangle(typeid(pm::UniPolynomial<pm::Rational,pm::Int>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_unipolynomial_quadraticextension_rational_int");
    realname = abi::__cxa_demangle(typeid(pm::UniPolynomial<pm::QuadraticExtension<pm::Rational>,pm::Int>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_polynomial_int_int");
    realname = abi::__cxa_demangle(typeid(pm::Polynomial<pm::Int,pm::Int>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_polynomial_integer_int");
    realname = abi::__cxa_demangle(typeid(pm::Polynomial<pm::Integer,pm::Int>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_polynomial_rational_int");
    realname = abi::__cxa_demangle(typeid(pm::Polynomial<pm::Rational,pm::Int>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_polynomial_double_int");
    realname = abi::__cxa_demangle(typeid(pm::Polynomial<double,pm::Int>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_polynomial_quadraticextension_rational_int");
    realname = abi::__cxa_demangle(typeid(pm::Polynomial<pm::QuadraticExtension<pm::Rational>,pm::Int>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_matrix_polynomial_rational_int");
    realname = abi::__cxa_demangle(typeid(pm::Matrix<pm::Polynomial<pm::Rational,pm::Int>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_vector_polynomial_rational_int");
    realname = abi::__cxa_demangle(typeid(pm::Vector<pm::Polynomial<pm::Rational,pm::Int>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_array_polynomial_integer_int");
    realname = abi::__cxa_demangle(typeid(pm::Array<pm::Polynomial<pm::Integer,pm::Int>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_array_polynomial_rational_int");
    realname = abi::__cxa_demangle(typeid(pm::Array<pm::Polynomial<pm::Rational,pm::Int>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_map_string_string");
    realname = abi::__cxa_demangle(typeid(pm::Map<std::string,std::string>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_map_string_int");
    realname = abi::__cxa_demangle(typeid(pm::Map<std::string,pm::Int>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_map_int_int");
    realname = abi::__cxa_demangle(typeid(pm::Map<pm::Int,pm::Int>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_map_integer_int");
    realname = abi::__cxa_demangle(typeid(pm::Map<pm::Integer,pm::Int>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_map_rational_rational");
    realname = abi::__cxa_demangle(typeid(pm::Map<pm::Rational,pm::Rational>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_map_set_int_integer");
    realname = abi::__cxa_demangle(typeid(pm::Map<pm::Set<pm::Int>,pm::Integer>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_map_set_int_rational");
    realname = abi::__cxa_demangle(typeid(pm::Map<pm::Set<pm::Int>,pm::Rational>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_map_set_int_vector_rational");
    realname = abi::__cxa_demangle(typeid(pm::Map<pm::Set<pm::Int>,pm::Vector<pm::Rational>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_map_vector_int_integer");
    realname = abi::__cxa_demangle(typeid(pm::Map<pm::Vector<pm::Int>,pm::Integer>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_incidencematrix_symmetric");
    realname = abi::__cxa_demangle(typeid(pm::IncidenceMatrix<pm::Symmetric>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_incidencematrix_nonsymmetric");
    realname = abi::__cxa_demangle(typeid(pm::IncidenceMatrix<pm::NonSymmetric>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_graph_directed");
    realname = abi::__cxa_demangle(typeid(pm::graph::Graph<pm::graph::Directed>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_graph_undirected");
    realname = abi::__cxa_demangle(typeid(pm::graph::Graph<pm::graph::Undirected>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_nodemap_directed_int");
    realname = abi::__cxa_demangle(typeid(pm::graph::NodeMap<pm::graph::Directed,pm::Int>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_nodemap_undirected_int");
    realname = abi::__cxa_demangle(typeid(pm::graph::NodeMap<pm::graph::Undirected,pm::Int>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_nodemap_directed_set_int");
    realname = abi::__cxa_demangle(typeid(pm::graph::NodeMap<pm::graph::Directed,pm::Set<pm::Int>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_nodemap_undirected_set_int");
    realname = abi::__cxa_demangle(typeid(pm::graph::NodeMap<pm::graph::Undirected,pm::Set<pm::Int>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_edgemap_directed_int");
    realname = abi::__cxa_demangle(typeid(pm::graph::EdgeMap<pm::graph::Directed,pm::Int>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_edgemap_undirected_int");
    realname = abi::__cxa_demangle(typeid(pm::graph::EdgeMap<pm::graph::Undirected,pm::Int>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_homologygroup_integer");
    realname = abi::__cxa_demangle(typeid(polymake::topaz::HomologyGroup<pm::Integer>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_array_homologygroup_integer");
    realname = abi::__cxa_demangle(typeid(pm::Array<polymake::topaz::HomologyGroup<pm::Integer>>).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    type_name_tuples[i] = jl_cstr_to_string("to_switchtable");
    realname = abi::__cxa_demangle(typeid(polymake::group::SwitchTable).name(), nullptr, nullptr, &status);
    type_name_tuples[i + 1] = jl_cstr_to_string(realname);
    free(realname);
    i += 2;

    return jlcxx::make_julia_array(type_name_tuples, 2 * number_of_types);
}

}

